Crystal::EventLoop::Epoll - Crystal 1.16.3

# class Crystal::EventLoop::Epoll

- Crystal::EventLoop::Epoll
- Crystal::EventLoop::Polling
- Crystal::EventLoop
- Reference
- Object

##
Defined in:

crystal/event_loop/epoll.cr

##
Constructors

- .new

##
Instance Method Summary

- #after_fork : Nil

  no parallelism issues, but let's clean-up anyway

- #after_fork_before_exec : Nil

  reset the mutexes since another thread may have acquired the lock of one event loop, which would prevent closing file descriptors for example.

- #interrupt : Nil

  Tells a blocking run loop to no longer wait for events to activate.

### Instance methods inherited from class `Crystal::EventLoop::Polling`

accept(socket : ::Socket) : ::Socket::Handle | Nil accept, after_fork : Nil after_fork, after_fork_before_exec : Nil after_fork_before_exec, close(file_descriptor : System::FileDescriptor) : Nil
close(socket : ::Socket) : Nil close, connect(socket : ::Socket, address : ::Socket::Addrinfo | ::Socket::Address, timeout : Time::Span | Nil) : IO::Error | Nil connect, create_timeout_event(fiber : Fiber) : FiberEvent create_timeout_event, read(file_descriptor : System::FileDescriptor, slice : Bytes) : Int32
read(socket : ::Socket, slice : Bytes) : Int32 read, receive_from(socket : ::Socket, slice : Bytes) : Tuple(Int32, ::Socket::Address) receive_from, run(blocking : Bool) : Bool run, send_to(socket : ::Socket, slice : Bytes, address : ::Socket::Address) : Int32 send_to, sleep(duration : Time::Span) : Nil sleep, wait_readable(file_descriptor : System::FileDescriptor) : Nil
wait_readable(socket : ::Socket) : Nil wait_readable, wait_writable(file_descriptor : System::FileDescriptor) : Nil
wait_writable(socket : ::Socket) : Nil wait_writable, write(file_descriptor : System::FileDescriptor, slice : Bytes) : Int32
write(socket : ::Socket, slice : Bytes) : Int32 write

### Instance methods inherited from class `Crystal::EventLoop`

create_resume_event(fiber : Fiber) : Event create_resume_event, create_timeout_event(fiber : Fiber) : Event create_timeout_event, interrupt : Nil interrupt, run(blocking : Bool) : Bool run, sleep(duration : Time::Span) : Nil sleep

### Constructor methods inherited from class `Crystal::EventLoop`

create : self create, current : self current

### Class methods inherited from class `Crystal::EventLoop`

backend_class backend_class, current? : self | Nil current?, remove(file_descriptor : Crystal::System::FileDescriptor) : Nil
remove(socket : ::Socket) : Nil remove

### Instance methods inherited from module `Crystal::EventLoop::Socket`

accept(socket : ::Socket) : ::Socket::Handle | Nil accept, close(socket : ::Socket) : Nil close, connect(socket : ::Socket, address : ::Socket::Addrinfo | ::Socket::Address, timeout : Time::Span | Nil) : IO::Error | Nil connect, read(socket : ::Socket, slice : Bytes) : Int32 read, receive_from(socket : ::Socket, slice : Bytes) : Tuple(Int32, ::Socket::Address) receive_from, send_to(socket : ::Socket, slice : Bytes, address : ::Socket::Address) : Int32 send_to, wait_readable(socket : ::Socket) : Nil wait_readable, wait_writable(socket : ::Socket) : Nil wait_writable, write(socket : ::Socket, slice : Bytes) : Int32 write

### Instance methods inherited from module `Crystal::EventLoop::FileDescriptor`

close(file_descriptor : Crystal::System::FileDescriptor) : Nil close, read(file_descriptor : Crystal::System::FileDescriptor, slice : Bytes) : Int32 read, wait_readable(file_descriptor : Crystal::System::FileDescriptor) : Nil wait_readable, wait_writable(file_descriptor : Crystal::System::FileDescriptor) : Nil wait_writable, write(file_descriptor : Crystal::System::FileDescriptor, slice : Bytes) : Int32 write

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new #

##
Instance Method Detail

def after_fork : Nil #
Description copied from class Crystal::EventLoop::Polling

no parallelism issues, but let's clean-up anyway

def after_fork_before_exec : Nil #
Description copied from class Crystal::EventLoop::Polling

reset the mutexes since another thread may have acquired the lock of one event loop, which would prevent closing file descriptors for example.

def interrupt : Nil #
Description copied from class Crystal::EventLoop

Tells a blocking run loop to no longer wait for events to activate. It may for example enqueue a NOOP event with an immediate (or past) timeout. Having activated an event, the loop shall return, allowing the blocked thread to continue.

Should be a NOOP when the loop isn't running or is running in a nonblocking mode.

NOTE we assume that multiple threads won't run the event loop at the same time in parallel, but this assumption may change in the future!